package macros.rpc;

import kernel.net.Net;
import kernel.net.Package.NetworkID;

using tink.CoreApi;

abstract class RPCBase {
	public final id:NetworkID;

	private final _proto:String;

	public function new(id:NetworkID, proto:String) {
		this.id = id;
		this._proto = proto;
	}

	private function _performRequest(func:String, args:Array<Dynamic>):Promise<Dynamic> {
		return Net.sendAndAwait(id, this._proto, {
			func: func,
			args: args
		}).map((res) -> {
			switch (res) {
				case Success(pack):
					return Success(pack.data);
				case Failure(_):
					return res;
			}
		});
	}
}
